﻿package 
{
	
	import flash.display.*;
	import flash.events.*;

	public class ChaseDemo extends Sprite
	{
		
		private const wSWF:Number = stage.width;
		private const hSWF:Number = stage.height;
		
		private var targetX:Number = wSWF/2;
		private var targetY:Number = hSWF/2;
		
		private var ship:Sprite;
		
		public function ChaseDemo()
		{
			init();
		}
		
		private function init():void
		{
						
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			
			// Creating a new Spacehip object
			ship = new Spaceship();
			addChild(ship);
			
			
			stage.addEventListener(Event.ENTER_FRAME,onEnter);
			stage.addEventListener(MouseEvent.MOUSE_MOVE, onMove);
		
			
		}
		
	
		private function onEnter(event:Event):void
		{
			//calculation for interpolating the ship's position
			ship.x = (0.90*ship.x + 0.1*targetX)-1;
			ship.y = (0.90*ship.y + 0.1*targetY)-1;
			
			var dx:Number = Math.abs(targetX - ship.x);
			var dy:Number = Math.abs(targetY - ship.y);
			//calculating the distance that the ship has travelled
			var distance:Number = Math.sqrt(dx*dx + dy*dy);
			
			if(distance >=450 )
			{
				distance = 450;
			}			
						
			//scaling the ship based on its y-position
			ship.scaleX = ship.scaleY = ship.y * 0.5 * 0.01;
		}
		
		
		private function onMove(event:MouseEvent):void
		{
			//sets the targetX whenever the mouse moves
			//this is the target which the object has to reach
			targetX = event.stageX;			
			targetY = event.stageY;


			if ( targetX < 30 ) 
				targetX = 30;
			if ( targetX > wSWF )
				targetX = wSWF;
				
			if ( targetY < 30 ) 
				targetY = 30;
			if ( targetY > hSWF-50 )
				targetY = hSWF-50;
		}
	}
}
